<?php

namespace Drupal\tacjs_domain\Form\Steps;

/**
 * Utility methods for the TacJS domain forms.
 */
trait DomainFormTrait {

  /**
   * {@inheritDoc}
   */
  protected function getConfig() {
    $config = parent::getConfig();
    // Required to inject all the domain-specific values into the config object
    // that will be need to be saved on form submission.
    // Otherwise, only the form specific values will be saved over the default
    // "All domains" values.
    // Domain issue #3513800 will fix that and make this module useless.
    $moduleOverrides = $this->getConfigModuleOverrides($config);
    if (!empty($moduleOverrides)) {
      $config->merge($moduleOverrides);
    }
    return $config;
  }

  /**
   * Get the moduleOverrides protected property value.
   *
   * @param \Drupal\Core\Config\Config $config
   *   The TacJS module configuration.
   *
   * @return mixed
   *   The overridden values.
   */
  protected function getConfigModuleOverrides($config) {
    $reflection = new \ReflectionClass($config);
    $property = $reflection->getProperty('moduleOverrides');
    $property->setAccessible(TRUE);
    return $property->getValue($config);
  }

}
